import { Collapsible } from './modules/collapsible.js';
import { removeItem } from './modules/removeitem.js';
import { initializeRevealTargets, setupRevealConditions, handleRevealConditions } from './modules/reveal.js';
import { copyToClipboard, createItem, toggleCollapsibleMetas, handleInputChange } from './modules/helpers.js';

const overviewSelectors = {
  collapsibleWrapper: '.collapsible-wrapper',
  clickableSelector: '.toggle-help-section__cta',
  contentSelector: '.help-section',
  textSelector: '.toggle-help-section__cta'
}

/* Landing page "/" */
Collapsible(overviewSelectors);
window.copyToClipboard = copyToClipboard;
window.createItem = createItem;
window.toggleCollapsibleMetas = toggleCollapsibleMetas;
window.handleInputChange = handleInputChange;
window.removeItem = removeItem;
window.initializeRevealTargets = initializeRevealTargets;
window.setupRevealConditions = setupRevealConditions;
window.handleRevealConditions = handleRevealConditions;