# Developer Portal

The Developer Portal provides a fully managed system to advertise, document and enable 
self-service provisioning of your API ecosystem.

## Features
- **Full, versatile CMS capabilities:**
    - Unlimited custom Layouts and page templates
    - Create custom page type definitions to create new pages with a 
      single click
    - Support for multiple, deeply nested navigation menus
    - Custom forms and form validation across any page type
    - Rich text editor with media embedding and file upload support
    - Preconfigured blogging solution to quickly and seamlessly create topic-focussed blog posts
- **Rich developer portal experience:**
    - Automatically discover all products live in your API Gateway
    - Attach OpenAPI documentation, metadata descriptions and even full CMS page content to enhance the documentation and context of your APIs
    - Enable users to browse multiple versions of your API documentation using the best-in-class ReDoc API documentation viewer
    - Create public or private catalogues for your APIs to ensure API discovery is limited to signed-in users or available to the public
    - Shopping-cart API smorgasbord experience:
        - Enable user to select which APIs they want access to
        - Provide multiple plans for users to provide free or monetised access solutions
        - Support for Oauth and Standard Token authentication

## Development Setup

1. Install development dependencies (taskfile, pre-commit)
   ```bash
   make install-dependencies
   ```
2. Set PORTAL_LICENSEKEY environment variable
   ```bash
   export PORTAL_LICENSEKEY="your license key here"
   ```
3. Run portal
   ```bash
   task run
   ```
## Docs
[Here](docs/readme.md) and also more detail in the [wiki](https://github.com/TykTechnologies/portal/wiki)
